/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_bkend_thread.h
//
// The C_OLAPBkend_Thread class represents the backend threads which 
// handle the issuing of requests and fetching of results from the
// backend.
//
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////


#if !defined(__OLAP_BKEND_THREAD_H)
#define	__OLAP_BKEND_THREAD_H

#include "olap_types.h"
#include "olap_thread.h"

#include "w_string.h"


class C_OLAPBkend_Thread : public C_OLAPThread_Thread
{
public :

	C_OLAPBkend_Thread(const w_string& schema, int32 threadno)
	{
		m_iMyself = threadno ; 
		m_isSchemaName = schema ;
	}
	
	virtual ~C_OLAPBkend_Thread()
	{
	}
				
	SOCKET Synchronize() ; 

	virtual	vo_ptr	Run() ; 

protected :

	int32					m_iMyself; 	
	w_string				m_isSchemaName ; 
} ;

#endif
