/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// apb_queries.h
//
// Declares functions which generate query trees corresponding to 
// APB benchmark queries.
//
// Author: Amit Shukla
//
/////////////////////////////////////////////////////////////////////


#ifndef _APB_QUERIES_H
#define _APB_QUERIES_H

#include "querytree.h"
#include "qt_attr.h"
#include "qt_expr.h"
#include "qt_join.h"
#include "qt_measure.h"

#include "borgtypes.h"

pQT_MDQuery Q1_ConstructQuery();
pQT_LogicalExpr Q1_ConstructLogicalExpr();
pQT_ProjList Q1_ConstructProjList();


pQT_MDQuery     Q2_ConstructQuery();
pQT_LogicalExpr Q2_ConstructLogicalExpr();
pQT_ProjList    Q2_ConstructProjList();

/*
 pQT_MDQuery     Q3_ConstructQuery();
 pQT_LogicalExpr Q3_ConstructLogicalExpr();
 pQT_ProjList    Q3_ConstructProjList();
*/

pQT_MDQuery     Q4_ConstructQuery();
pQT_LogicalExpr Q4_ConstructLogicalExpr();
pQT_ProjList    Q4_ConstructProjList();


pQT_MDQuery     Q5_ConstructQuery();
pQT_LogicalExpr Q5_ConstructLogicalExpr();
pQT_ProjList    Q5_ConstructProjList();


pQT_MDQuery     Q6_ConstructQuery();
pQT_LogicalExpr Q6_ConstructLogicalExpr();
pQT_ProjList    Q6_ConstructProjList();


pQT_MDQuery     Q7_ConstructQuery();
pQT_LogicalExpr Q7_ConstructLogicalExpr();
pQT_ProjList    Q7_ConstructProjList();


pQT_MDQuery     Q8_ConstructQuery();
pQT_LogicalExpr Q8_ConstructLogicalExpr();
pQT_ProjList    Q8_ConstructProjList();


pQT_MDQuery     Q9_ConstructQuery();
pQT_LogicalExpr Q9_ConstructLogicalExpr();
pQT_ProjList    Q9_ConstructProjList();


pQT_MDQuery     Q10_ConstructQuery();
pQT_LogicalExpr Q10_ConstructLogicalExpr();
pQT_ProjList    Q10_ConstructProjList();

#endif
