/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_shutdown.cpp
//
// Sends a shutdown request to the BORG server.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////



#include <iostream.h>
#include <stdlib.h>
#include <math.h>

#include "olap_comm_generic.h"
#include "olap_tuple_client_native.h"

extern "C" long random() ; 

u_int32         OlapMsgInquiryPort = 0;
u_int32         OlapMsgServicePort = 0;
u_int32         OlapClientServicePort = 0;
u_int32         OlapServerShutdownPort = 0;

void SetPortNumbers()
{
        OlapMsgInquiryPort = OLAP_MSG_INQUIRY_PORT;
        OlapMsgServicePort = OLAP_MSG_SERVICE_PORT;
        OlapClientServicePort = OLAP_CLIENT_SERVICE_PORT;
        OlapServerShutdownPort = OLAP_SERVER_SHUTDOWN_PORT;

        ifstream inp(".ports");
        if (!inp) return;

        inp >> OlapMsgInquiryPort ;
        while (inp.get() != '\n');
        inp >> OlapMsgServicePort ;
        while (inp.get() != '\n');
        inp >> OlapClientServicePort ;
        while (inp.get() != '\n');
        inp >> OlapServerShutdownPort ;
}

main( int argc, char* argv[] )
{
	char* hostName = NULL ; 

	SetPortNumbers();

	if ( argc < 2 || argc > 3 )
	{
		cerr << argv[0] << " <host-name> [<host-port>]" << endl ; 
		exit(1) ; 
	}

	if ( argc == 3 ) OlapServerShutdownPort = atoi(argv[2]) ; 
	hostName = argv[1] ; 

	// Initialize the comm system
	W_COERCE( C_OLAPComm_System::Initialize() ) ; 

	// Connect to the shutdown port
	SOCKET s = C_OLAPComm_System::CreateNetDomainCltSocket( hostName, OlapServerShutdownPort ) ; 
	if ( s == INVALID_SOCKET )
	{
		cerr << "Unable to connect to server" << endl ; 
		exit(1) ; 
	}

	C_OLAPComm_System_Generic_Client		isClient(s,true) ; 
	C_OLAPComm_Reconciler				isReconciler ; 

	C_OLAPComm_Shutdown_Packet		isShutdown ; 	

	// Send a request 
	W_COERCE( isClient.SendData( isReconciler, isShutdown ) ) ; 

	W_COERCE( C_OLAPComm_System::Shutdown() ) ; 
}
