/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////// 
// 	
// olap_comm_client_test.cpp:  
// 
// code for testing the communication component. creates a data linearizer 
// that flattens the various data and send it over the wire using generic 
// packet. Waits until a packet is received from the server and prints them
// 
// Author: Karthikeyan Ramasamy
// 
/////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <sys/types.h>
#include <netinet/in.h> 

#include "olap_types.h"
#include "olap_comm_types.h"
#include "olap_comm_system_generic.h"


int main(int argc, char* argv[])
{
	if ( argc != 3 )
	{
		cerr << argv[0] << " : host-name port-number " << endl ;
		exit(1) ;
	}

	C_OLAPComm_System_Generic_Client	isClient ; 
	C_OLAPComm_Reconciler			isReconciler ;

	if ( isClient.Connect(argv[1], atoi(argv[2])) < 0 )
	{
		cerr << "Error in connecting..." << endl ;
		exit(1) ;
	}

	C_OLAPComm_DataLinearizer		isData ;

	isData.Pack( int32(200) );
	isData.Pack( "i am here" );

	C_OLAPComm_Generic_Packet isPacket(isData) ;
	
	if ( isClient.SendData( isReconciler, isPacket ) < 0 )
	{
		cerr << "Unable to send data..." << endl ;
		exit(1) ;
	}

	C_OLAPComm_Packet*		pPacket = NULL ;

	if ( isClient.ReceiveData( isReconciler, pPacket ) < 0 )
	{
		cerr << "Unable to recv data..." << endl ;
		exit(1) ;
	}
	
	C_OLAPComm_DataDelinearizer*		isNetData ;
 
	isNetData = ((C_OLAPComm_Generic_Packet*)pPacket)->GetDataDelinearizer();

	int32 istrlen;
        char Res[8192] ; int ResSize = 8192 ; 

	isNetData->Unpack(istrlen);
	isNetData->Unpack(Res, ResSize);

        cout << Res << endl ; 

	exit(0) ;
}
