/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_comm_data.cpp:
//
// This file contains that swizzles data types depending the machine 
// architecture (little endian or big endian). Also contains definitions
// for packing and unpacking the various data types.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#include "olap_types.h"
#include "olap_comm_types.h"
#include "olap_comm_data.h"

void C_OLAPComm_Endian_Convertors::ReverseMemory( void* Destination,
												  const void* Source,
												  int32	Length )
{
	const char* szSource = (const char *)Source ;
	char* szDestination = (char *)Destination ;
	szSource = szSource + Length - 1 ;
	while( Length-- > 0 ) *szDestination++ = *szSource-- ;
}

void C_OLAPComm_DataDelinearizer::Unpack( char* szString, int32 &iLen )
{
	int32 iNetworkLen ;
	Unpack( iNetworkLen ) ;

	if ( iNetworkLen-1 > iLen )
	{
		iLen = -1 ; return ;
	}
 
	m_isInputData.read( szString, iNetworkLen ) ;
	szString[iNetworkLen] = char(NULL) ; 
}
