/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_comm_msgheader.cpp
//
// This file contains some of the method definitions related with the
// protocol message header used in the communication
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(_WINDOWS)
#include <sys/types.h>
#include <netinet/in.h>
#endif

#include "olap_types.h"
#include "olap_comm_types.h"
#include "olap_comm_msgheader.h"

const int C_OLAPComm_Header::ms_iEndianExtractor = 0x1 ;
const int C_OLAPComm_Header::ms_iMoreDataExtractor = 0x2;

ostream& operator <<(ostream& os, const C_OLAPComm_Header& isHeader)
{
	os << "(pkt-type " << isHeader.m_iPktType << "),"
	   << "(ctrl-info " << isHeader.m_iCtlInfo << "),"
	   << "(length " << isHeader.m_iLength << ")," << endl ; 
           
	return os ; 
}

