/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_comm_pkt.cpp
//
// This file contains the method definitions related with the
// type of data packets exchanged between client and server 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#include "olap_comm_pkt.h"
#include "olap_page.h"

bool C_OLAPComm_Generic_Packet::Delinearize( OLAPCOMM_ENDIAN_TYPE isEndian )
{
	m_isDataDelinearizer =
			new C_OLAPComm_DataDelinearizer(
					m_szNetworkData,
					m_iNetworkDataLength,
					isEndian ) ;

	if ( !m_isDataDelinearizer ) W_FATAL(BORG_OUTOFMEMORY) ;

	return true ;
}

bool C_OLAPComm_Stream_Packet::Linearize()
{
	m_szNetworkData = (char *)m_isPage ;
	m_iNetworkDataLength = C_OLAP_Page::page_sz ;
	
	m_bMemoryOut = true; // so that destructor does not delete the memory
	return true ;
}

bool C_OLAPComm_Stream_Packet::Delinearize( OLAPCOMM_ENDIAN_TYPE /*isEndian*/ )
{
	m_isPage = new C_OLAP_Page ;

	if ( !m_isPage ) W_FATAL(BORG_OUTOFMEMORY) ;

	memcpy( (void *)m_isPage, m_szNetworkData, m_iNetworkDataLength ) ;
	delete [] m_szNetworkData;
	m_szNetworkData = NULL;
	m_iNetworkDataLength = 0;
	return true ;
}

C_OLAPComm_Stream_Packet::~C_OLAPComm_Stream_Packet()
{
	if (!m_bMemoryOut)
	{
		if (m_szNetworkData )
        		delete [] m_szNetworkData ;
		if (m_isPage)
			delete m_isPage;
	}
}
