/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_comm_reconciler.h
//
// This file declares the class that acts as a clue between the 
// transport layer (that actually ships data) and the data packets
// that are being exchanged. The primary responsibility of this 
// class to format the data before shipping and after receiving. 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////


#if !defined(__OLAP_COMM_RECONCILER_H)
#define __OLAP_COMM_RECONCILER_H

#include "olap_comm_msgheader.h"
#include "olap_comm_pkt.h"

class C_OLAPComm_Reconciler {

public :

	C_OLAPComm_Reconciler()
	{

	}

	virtual ~C_OLAPComm_Reconciler()
	{

	}

	void GenerateMsgHeader( C_OLAPComm_Packet& isPacket, 
		                    C_OLAPComm_Header& isHeader ) ;

	void GenerateNetworkData( C_OLAPComm_Packet& isPacket,
		                      char*& szNetworkData,
							  int32& iNetworkDataLength ) ;

	void ExtractNetworkData( C_OLAPComm_Packet& isPacket,
							 char*   szNetworkData,
							 C_OLAPComm_Header& isHeader ) ;

	C_OLAPComm_Packet* CreatePacket(C_OLAPComm_Header& isHeader) ;

} ;


#endif
