/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_comm_types.h
//
// This file contains the various data types definition used by 
// communication component. 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_COMM_TYPES_H)
#define __OLAP_COMM_TYPES_H

#if defined(_WINDOWS)
#include <winsock.h>
#endif

#if defined(SOLARIS2)
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#endif

enum OLAPCOMM_ENDIAN_TYPE {

	OLAPCOMM_BIG_ENDIAN = 0,
	OLAPCOMM_LITTLE_ENDIAN
} ;

enum OLAPCOMM_PACKET_TYPE {

	OLAPCOMM_NULL_PACKET = 1, 
	OLAPCOMM_GENERIC_PACKET,
	OLAPCOMM_EXIT_PACKET,
	OLAPCOMM_ERROR_PACKET,
	OLAPCOMM_SUCCESS_PACKET,
	OLAPCOMM_EMPTY_PACKET,
	OLAPCOMM_STREAM_PACKET,
	OLAPCOMM_SHUTDOWN_PACKET
} ;

//
// Change the endians depending on the type of architecture
// you are compiling on
// 
#if defined(I386)
const OLAPCOMM_ENDIAN_TYPE	gc_isMyEndian = OLAPCOMM_LITTLE_ENDIAN ;
#else
const OLAPCOMM_ENDIAN_TYPE	gc_isMyEndian = OLAPCOMM_BIG_ENDIAN ;
#endif

#if !defined(_WINDOWS)
typedef	int	SOCKET ; 
const SOCKET	INVALID_SOCKET	= -1 ;
const SOCKET	SOCKET_ERROR	= -1 ;
#endif

const u_int16 OLAP_MSG_INQUIRY_PORT = 9400 ; 
const u_int16 OLAP_MSG_SERVICE_PORT = 9500 ; 
const u_int16 OLAP_CLIENT_SERVICE_PORT = 9600 ; 
const u_int16 OLAP_SERVER_SHUTDOWN_PORT = 9700 ; 
const u_int16 OLAP_DB_SERVER_PORT = 9800 ; 
 
const int32 OLAP_BUFFER_SIZE = 8192 ; 

#include "borgcomm_error_def_gen.h"
#include "borg_error_def_gen.h"

#endif
