/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

#include "olap_msg.h"
#include "olap_msg_client.h"
#include "olap_comm_generic.h"

#include <fstream.h>

vo_ptr C_OLAPMsg_Client_Thread::Run()
{
	int fd = C_OLAPComm_System::CreateNetDomainCltSocket( "beatrice", OLAP_MSG_SERVICE_PORT ) ;

	if ( fd < 0 )
	{
		cerr << "unable to connect to server" << endl ; 
		return NULL;
	}

	strstream	str ; 
	str << "/tmp/" << m_isId.id() << ends ; 
 
	ofstream	outf(str.str()) ; 
	str.freeze(0) ;

        C_OLAPComm_Reconciler           isReconciler ;

        // Get the client interested from the msg client
        C_OLAPComm_DataLinearizer    	isData ; 

	m_isId.Linearize( isData ) ; 
        C_OLAPComm_Generic_Packet      	isPacket(isData) ; 

	C_OLAPComm_System_Generic_Client	isClient(fd) ; 	

	if ( isClient.SendData( isReconciler, isPacket ) < 0 )
	{
		cerr << " unable to send to server" << endl ; 
		return NULL; 
	}

	while (1)
	{
		C_OLAPMsg			msg_item ; 

        	// Get the client interested from the msg client
        	C_OLAPComm_DataDelinearizer*    qData = NULL ;
        	C_OLAPComm_Packet*              pPacket = NULL ;
        	C_OLAPComm_Generic_Packet*      recvPkt = NULL ;

        	if ( isClient.ReceiveData(isReconciler, pPacket) < 0 )
		{
			cerr << " unable to receive from the server" << endl ; 
			return NULL; 
		}

		if ( pPacket->GetPktType() == OLAPCOMM_EXIT_PACKET )
			break ; 

		recvPkt = (C_OLAPComm_Generic_Packet *)pPacket ; 
        	qData = recvPkt->GetDataDelinearizer();
	
		msg_item.DeLinearize( *qData ) ; 
			
		cout << lockp << msg_item << endl << unlockp ; 
		outf << msg_item << endl ; 
	}	
	
	cout << lockp << "Client " << m_isId << " done" << endl << unlockp ;  
	return NULL ; 
}

int main(int argc, char* argv[])
{
	int num_of_clients = atoi(argv[1]) ;

	for ( int i = 0 ; i < num_of_clients ; i++ )
	{
		C_OLAPMsg_Client_Thread* xx = new C_OLAPMsg_Client_Thread(i) ; 

		xx->Start() ; 
	}


	while (1) ; 
}
