/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_msg.cpp
//
// This file contains the implementation of the olap messging class 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#include "olap_server_macros.h"
#include "olap_msg.h"

int32 C_OLAPMsg::OLAP_MSG_ALL_CLIENTS = -1 ;

C_OLAPMsg& C_OLAPMsg::operator = ( const C_OLAPMsg& anMsg )
{
	m_isClientId = anMsg.m_isClientId ; 
	m_isMsgClass = anMsg.m_isMsgClass ;  
	m_isMsgSubClass = anMsg.m_isMsgSubClass ;  
	m_iMsgCode = anMsg.m_iMsgCode ; 
        m_isErrString = anMsg.m_isErrString ;

	return *this ; 
}

void
C_OLAPMsg::Linearize( C_OLAPComm_DataLinearizer& dLin )
{
	m_isClientId.Linearize( dLin ) ; 
	dLin.Pack( int32(m_isMsgClass) ) ; 
	dLin.Pack( int32(m_isMsgSubClass) ) ; 
	dLin.Pack( m_iMsgCode ) ; 
	dLin.Pack( m_isErrString ) ;
}

void
C_OLAPMsg::DeLinearize( C_OLAPComm_DataDelinearizer& dLin )
{
	m_isClientId.DeLinearize( dLin ) ; 
	dLin.Unpack( (int32 &)m_isMsgClass ) ; 
	dLin.Unpack( (int32 &)m_isMsgSubClass ) ; 
	dLin.Unpack( m_iMsgCode ) ; 
	dLin.Unpack( m_isErrString ) ;
}

ostream& operator << ( ostream& os, const C_OLAPMsg& msg_item )
{
	os	<< msg_item.m_isClientId << " " 
		<< int32(msg_item.m_isMsgClass) << " "
		<< int32(msg_item.m_isMsgSubClass) << " "
		<< msg_item.m_iMsgCode << " "
		<< msg_item.m_isErrString ;

	return os ; 
}

#ifdef __GNUG__
template class w_list_t<C_OLAPMsg>;
template class w_list_i<C_OLAPMsg>;
#endif

