/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_msg_util.cpp
//
// This file contains various utility functions that are needed
// by the messaging system. 
//
// VerboseMessage : provides a short cut to dump verbose messages
// 		    from the server to the client.
// 
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#include "olap_msg.h"
#include "olap_msg_queue.h"
#include "olap_client_thread.h"
#include "olap_msg_thread.h"

void VerboseMessage( strstream& strs )
{
	C_OLAPBorg_Thread::olap_thread_type ttype = 
		C_OLAPBorg_Thread::GetCurrentThread()->GetThreadType() ; 

	if ( ttype == C_OLAPBorg_Thread::OLAP_CLIENT_THREAD ) 
	{
		C_OLAPClient_Thread* client_thread = 
		(C_OLAPClient_Thread *)C_OLAPBorg_Thread::GetCurrentThread() ; 

		C_OLAPMsg       msg_item( int(client_thread->GetClientId()),
					  C_OLAPMsg::OLAP_MSG_VERBOSE,
					  C_OLAPMsg::OLAP_MSG_SERVER_VERBOSE,
					  0,
					  strs.str() ) ; 

		W_COERCE( g_MsgQueue.enqueue( msg_item ) ) ; 
	}

	if ( ttype == C_OLAPBorg_Thread::OLAP_MSG_ROUTER_THREAD ) 
	{
		// C_OLAPMsg_Router_Thread* router_thread = 
		// (C_OLAPMsg_Router_Thread *)C_OLAPBorg_Thread::GetCurrentThread() ; 

		C_OLAPMsg       msg_item( 0,
					  C_OLAPMsg::OLAP_MSG_VERBOSE,
					  C_OLAPMsg::OLAP_MSG_SERVER_VERBOSE,
					  0,
					  strs.str() ) ; 

		W_COERCE( g_MsgQueue.enqueue( msg_item ) ) ; 
	}
}



