/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_cache_operator.h
//
// This file consists of the definition of the olap cache operator
// derived from the abstract operator class. 
//
// Author: Prasad Deshpande
//
/////////////////////////////////////////////////////////////////////

#ifndef __OLAP_CACHE_OPERATOR_H
#define	__OLAP_CACHE_OPERATOR_H

#include "olap_operator_abstract.h"
#include "olap_execsql.h"

class C_OLAPOperator_Cache : public C_OLAPOperator 
{
public:

    C_OLAPOperator_Cache( C_OLAPPlan_Cache_Node* node ) :
	C_OLAPOperator(node,1,1)
    { 
	m_isCacheNode = node ; 
    } 
 
    virtual ~C_OLAPOperator_Cache() 
    { } 

    w_rc_t start() ; 
    w_rc_t run() ; 
    w_rc_t shutdown() ; 

protected:
    C_OLAPPlan_Cache_Node*		m_isCacheNode ; 
    C_OLAP_ExecSql			m_isExecSql ;

};

#endif
