/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_merge_operator.h
//
// This file consists of the definition of the olap merge operator
// used to merge its input streams into a single stream of output. 
// It is derived from the abstract operator class. 
//
// Author: Karthikeyan Ramasamy 
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_MERGE_OPERATOR_H)
#define	__OLAP_MERGE_OPERATOR_H

#include "w_bitmap.h"
#include "olap_operator_abstract.h"

class C_OLAPPlan_Merge_Node ; 

class C_OLAPOperator_Merge : public C_OLAPOperator 
{
public:

	C_OLAPOperator_Merge( C_OLAPPlan_Merge_Node* node ) ;

	virtual ~C_OLAPOperator_Merge() 
	{ } 

	virtual w_rc_t start() ; 
	virtual w_rc_t run() ; 
	virtual w_rc_t shutdown() ;

protected:

	w_rc_t ReadAndWrite( int32 ipStream, bool& eos, bool& exception ) ;

	w_bitmap_t		m_isEndOfStrReached ;
	C_OLAPPlan_Merge_Node*	m_isMergeNode ; 
} ; 

#endif

