/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_shutdown_operator.h
//
// This file consists of the definition of the shutdown operator
// that shuts down the operator threads. Derived from abstract
// operator class.
// 
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_SHUTDOWN_OPERATOR_H)
#define	__OLAP_SHUTDOWN_OPERATOR_H

#include "olap_operator_abstract.h"

class C_OLAPOperator_Shutdown : public C_OLAPOperator 
{
public:

	C_OLAPOperator_Shutdown() : C_OLAPOperator(NULL,0,0)
	{ 
		m_bShutdown = true ; 
	} 
 
	virtual ~C_OLAPOperator_Shutdown() 
	{ } 

	w_rc_t start()
	{
		return RCOK ; 
	}
 
	w_rc_t run()  
	{
		return RCOK ; 
	}

	w_rc_t shutdown() 
	{
		return RCOK ; 
	}
} ; 

#endif
