/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_sql_operator.h
//
// This file consists of the definition of the exec sql operator 
// for executing a given sql in the backend and streaming the 
// results received.  
// 
// It is derived from the abstract operator class. 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_SQL_OPERATOR_H)
#define	__OLAP_SQL_OPERATOR_H

#include "olap_operator_abstract.h"

class C_OLAPBkend_WrkrInfo ; 
class C_OLAPBkend_Sql_Request ;
class C_OLAPPlan_Sql_Node ; 
 
class C_OLAPOperator_Sql : public C_OLAPOperator 
{
public:

	C_OLAPOperator_Sql( C_OLAPPlan_Sql_Node* node ) : C_OLAPOperator(node,1,1)
	{ 
		m_isSqlNode = node ; 
	} 
 
	virtual ~C_OLAPOperator_Sql() 
	{ } 

	w_rc_t start() ; 
	w_rc_t run() ; 
	w_rc_t shutdown() ; 

protected:

	w_rc_t SubmitBkendRequest( C_OLAPBkend_WrkrInfo* info ) ; 

	C_OLAPBkend_Sql_Request*	m_isRequest ;
        C_OLAPBkend_WrkrInfo*           m_isFreeWorker ;
	C_OLAPPlan_Sql_Node*		m_isSqlNode ; 
        C_OLAPTuple_ShoreNetwork_Stream*m_isStream ;
} ; 

#endif
