/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_test_operator.h
//
// This file consists of the definition of a test operator used for
// testing the operator framework.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_TEST_OPERATOR_H)
#define	__OLAP_TEST_OPERATOR_H

#include "olap_operator.h"

class C_OLAPPlan_Producer_Node	; 
class C_OLAPOperator_Producer : public C_OLAPOperator 
{
public:

	C_OLAPOperator_Producer( C_OLAPPlan_Producer_Node* node ) : C_OLAPOperator(node,0,1)
	{ 
		m_isProducerNode = node ; 
	}

	virtual ~C_OLAPOperator_Producer() 
	{ } 

	virtual w_rc_t start()
	{
		return RCOK ; 
	}

	w_rc_t run() ; 

	w_rc_t shutdown() 
	{
		return RCOK ; 
	}

protected:

	C_OLAPPlan_Producer_Node*	m_isProducerNode ; 

} ; 

class C_OLAPBkend_Sql_Request ;  
class C_OLAPBkend_WrkrInfo ;
class C_OLAPTuple_ShoreNetwork_Stream ; 
class C_OLAPPlan_BkendProducer_Node ; 

class C_OLAPOperator_BkendProducer : public C_OLAPOperator
{
public:

	C_OLAPOperator_BkendProducer( C_OLAPPlan_BkendProducer_Node* node ) : C_OLAPOperator(node,1,1)
	{ 
		m_isBackendProducer = node ; 

		m_isFreeWorker = NULL ; m_isRequest = NULL ; m_isStream = NULL ; 
	}  

	virtual ~C_OLAPOperator_BkendProducer()
	{ } 

	virtual w_rc_t start() ;
	virtual w_rc_t run() ; 
	virtual w_rc_t shutdown() ; 

protected:

	C_OLAPBkend_WrkrInfo*			m_isFreeWorker ;
	C_OLAPBkend_Sql_Request*		m_isRequest ; 
	C_OLAPTuple_ShoreNetwork_Stream*	m_isStream ;

	C_OLAPPlan_BkendProducer_Node*		m_isBackendProducer ; 
} ;


// ---------------------------------------------------------------
// Added by Amit


class C_OLAPOperator_Producer_1 : public C_OLAPOperator 
{
public:

	C_OLAPOperator_Producer_1( C_OLAPPlan_Producer_Node_1* node ) : C_OLAPOperator(node,0,1)
	{ 
		m_isProducerNode_1 = node ; 
	}

	virtual ~C_OLAPOperator_Producer_1() 
	{ } 

	virtual w_rc_t start()
	{
		return RCOK ; 
	}

	w_rc_t run() ; 

	w_rc_t shutdown() 
	{
		return RCOK ; 
	}

protected:

	C_OLAPPlan_Producer_Node_1*		m_isProducerNode_1 ;
} ; 


class C_OLAPOperator_Producer_2 : public C_OLAPOperator 
{
public:

	C_OLAPOperator_Producer_2( C_OLAPPlan_Producer_Node_2* node ) : C_OLAPOperator(node,0,1)
	{ 
		m_isProducerNode_2 = node ; 
	}

	virtual ~C_OLAPOperator_Producer_2() 
	{ } 

	virtual w_rc_t start()
	{
		return RCOK ; 
	}

	w_rc_t run() ; 

	w_rc_t shutdown() 
	{
		return RCOK ; 
	}

protected:

	C_OLAPPlan_Producer_Node_2*		m_isProducerNode_2 ;
} ; 


class C_OLAPOperator_ExprTest : public C_OLAPOperator 
{
public:

	C_OLAPOperator_ExprTest( C_OLAPPlan_ExprTest_Node* node ) : C_OLAPOperator(node,2,1)
	{ 
		m_isExprNode = node ; 
	}

	virtual ~C_OLAPOperator_ExprTest() 
	{ } 

	virtual w_rc_t start()
	{
		return RCOK ; 
	}

	w_rc_t run() ; 

	w_rc_t shutdown() 
	{
		return RCOK ; 
	}

protected:

	C_OLAPPlan_ExprTest_Node*		m_isExprNode ; 
} ; 

#endif

