/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////
//
// olap_meta_plan.h
//
// This file defines the interface for meta data plan to be executed
// when meta-data is loaded from the backend. 
//
// Author: Amit Shukla
//
/////////////////////////////////////////////////////////////////////

#ifndef __OLAP_META_PLAN_H
#define __OLAP_META_PLAN_H

#include "olap_plan.h"
#include <string>
#include "metadatabasics.h"

class C_OLAP_AllSchemas_Physical_Plan : public C_OLAP_Physical_Plan  
{

public:
    C_OLAP_AllSchemas_Physical_Plan(string& dbname, Map* schema) 
	: C_OLAP_Physical_Plan(), m_isDBName(dbname), m_isSchemas(schema)
    { }

    ~C_OLAP_AllSchemas_Physical_Plan()
    { }

    void BuildPlan();

private:
    string&   m_isDBName;
    Map*      m_isSchemas;
};



class CSchemaNode;

class C_OLAP_LoadSchema_Physical_Plan : public C_OLAP_Physical_Plan  
{

public:
    C_OLAP_LoadSchema_Physical_Plan(string& dbname, CSchemaNode* schemaptr) 
	: C_OLAP_Physical_Plan(), m_isDBName(dbname), m_isSchema(schemaptr)
    { }

    ~C_OLAP_LoadSchema_Physical_Plan()
    { }

    void BuildPlan();

private:
    string&        m_isDBName;
    CSchemaNode*   m_isSchema;
};


#endif

