/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////
//
// olap_plan.h
//
// This file defines the tree structure of the physical plan 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_PLAN_H)
#define	__OLAP_PLAN_H

#include "w.h"
#include "olap_stream.h"

class C_OLAPPlan_Node ;
class C_OLAPTuple_ShoreClientStream ;

class QT_MDQuery;


class C_OLAP_Physical_Plan  
{
public:

        C_OLAP_Physical_Plan()
        { 
		m_isRoot = NULL ; 
	}

        virtual ~C_OLAP_Physical_Plan() ;

       	void testPlan() ;  
       	void testPlan1() ;  
       	void testPlan2() ;  
       	void testPlan3() ;  
       	void testPlan4() ;  
        void testPlan5() ;
        void GenSqlPlan(const w_string &database, const w_string &sql,
                        C_OLAP_TupleInfo *tupInfo) ;
	virtual w_rc_t executePlan( C_OLAPStream* result ) ; 

        
	C_OLAPPlan_Node* GetRoot() 
	{
		return	m_isRoot ; 
	}
	
protected:

	static w_rc_t startOperators( C_OLAPPlan_Node* root_node ) ; 
	static w_rc_t waitOpTreeCompletion( C_OLAPPlan_Node* root_node ) ; 

	static w_rc_t instantiatePlan( C_OLAPPlan_Node* root_node ) ; 
	static void destroyPlan( C_OLAPPlan_Node* root_node ) ; 

	static w_rc_t getOperatorError( C_OLAPPlan_Node* root_node ) ; 
	
	C_OLAPPlan_Node*		m_isRoot ; 

} ;

#endif
