/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////
//
// olap_tree.h
//
// This file defines the generic tree node structure for use with 
// physical plan.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_TREE_H)
#define	__OLAP_TREE_H

#include "w_dynarray.h"

class C_OLAPTreeNode ; 

typedef dynarray<C_OLAPTreeNode*>	ChildArgs; 

class C_OLAPTree_Node {
public:

	C_OLAPTreeNode*	child(int32 n)
	{ 
		return m_isChild[n] ;
	}
	
	void add_child(int32 n, C_OLAPTreeNode* aNode)
	{
		m_isChild[n] = aNode ; 
	}

	void add_child(C_OLAPTreeNode* aNode)
	{
		m_isChild.push_back(aNode) ; 
	}

	int32 num_child()
	{
		return m_isChild.vectorSize() ; 
	}

protected:

	ChildArgs 			m_isChild ; 
} ; 

#endif
