INCLUDE += \
	$(FC_INCL)		\
	$(COMMON_INCL)		\
	$(STHREAD_INCL)		\
	$(SM_INCL)		\
	$(OLAP_SHARE_INCL)	\
	$(OLAP_COMM_INCL)	\
	$(OLAP_THREAD_INCL)	\
	$(OLAP_MSG_INCL)	\
	$(OLAP_BKEND_INCL)	\
	$(OLAP_BKEND_SYBASE_INCL)	\
	$(OLAP_STREAM_INCL)	\
	$(OLAP_OPERATOR_INCL)	\
	$(OLAP_PPLAN_INCL)	\
	$(OLAP_QPROC_INCL)	\
	$(OLAP_QTREE_INCL)	\
	$(OLAP_META_INCL)	\
	$(OLAP_CACHE_INCL)	\
	$(OLAP_SERVER_INCL) 

server.SRC.h = \
	olap_borg_thread.h	\
	olap_client_thread.h	\
	olap_main_thread.h	\
	olap_server_globals.h	\
	olap_server_macros.h	\
	olap_client_id.h	\
	olap_bkend_request.h 

server.SRC.cpp = \
	olap_client_thread.cpp	\
	olap_client_id.cpp	\
	olap_main_thread.cpp 	\
	olap_bkend_request.cpp 

server_exec.SRC.cpp = olap_server.cpp

ERROR_FILES = borg_error_def_gen.h borg_errmsg_gen.h borg_einfo_gen.h

server.OBJS = objs_from_sources($(server.SRC.cpp))
server_exec.OBJS = objs_from_sources($(server_exec.SRC.cpp))

SRC_perm.cpp += $(server.SRC.cpp) $(server_exec.SRC.cpp) 
SRC_perm.h += $(server.SRC.h)

SV_EXEC = borg-server

server.LIB = \
	$(OLAP_SERVER_LIB)		\
	$(OLAP_BKEND_LIB)		\
	$(OLAP_BKEND_SERVER_ALL)	\
	$(OLAP_PPLAN_LIB)		\
	$(OLAP_META_LIB)		\
	$(OLAP_PPLAN_LIB)		\
	$(OLAP_OPERATOR_LIB)		\
	$(OLAP_CACHE_LIB)		\
	$(OLAP_OPERATOR_LIB)		\
	$(OLAP_QPROC_LIB)		\
	$(OLAP_META_LIB)		\
	$(OLAP_QTREE_LIB)		\
	$(OLAP_STREAM_SERVER_LIB)	\
	$(OLAP_STREAM_CLIENT_LIB)	\
	$(OLAP_COMM_SERVER_LIB) 	\
	$(OLAP_COMM_CLIENT_LIB) 	\
	$(OLAP_MSG_LIB)			\
	$(OLAP_THREAD_LIB)		\
	$(OLAP_SHARE_LIB)		\
	$(OLAP_SERVER_LIB)		\
	$(SHORE_LIBS)

gen_error_codes(borg_error.dat, -d, $(ERROR_FILES))

build_library($(OLAP_SERVER_LIB), $(server.OBJS))

build_timestamped_exec($(SV_EXEC), $(server_exec.OBJS), $(server.LIB))

install_copy(bin, $(SV_EXEC))
