/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////
//
// olap_borg_thread.h
//
// This file defines the abstract class of all the threads defined
// in BORG 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_BORG_THREAD_H)
#define	__OLAP_BORG_THREAD_H

#include "olap_server_globals.h"

class C_OLAPBorg_Thread : public smthread_t
{
public:

	enum olap_thread_type {

		OLAP_MAIN_THREAD = 1,
		OLAP_CLIENT_THREAD,
		OLAP_CLIENT_SERVICE_THREAD,
		OLAP_MSG_THREAD,
		OLAP_MSG_SERVICE_THREAD,
		OLAP_MSG_ROUTER_THREAD,
		OLAP_MSG_INQUIRY_THREAD,
		OLAP_OPERATOR_THREAD,
		OLAP_BKEND_THREAD
	} ; 	

	static C_OLAPBorg_Thread* GetCurrentThread()
	{
		return (C_OLAPBorg_Thread *)smthread_t::me() ; 
	}

	virtual olap_thread_type GetThreadType() = 0 ; 

	id_t ThreadId() { return id ; }

protected:

} ; 

#endif
