/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////
//
// olap_client_id.h
//
// This file defines the ids for clients 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_CLIENT_ID_H)
#define	__OLAP_CLIENT_ID_H

#include <iostream.h>
#include "olap_types.h"

#include "olap_comm_data.h"

class C_OLAPClient_Id : public C_OLAPComm_Data 
{
public:

	C_OLAPClient_Id()
	{ } 

        C_OLAPClient_Id( int32 anId )
        { 
		m_iId = anId; 
	} 

        ~C_OLAPClient_Id()
        { } 

        C_OLAPClient_Id& operator = (const C_OLAPClient_Id& anId)
        {
		m_iId = anId.m_iId ; return *this ;
        }

	bool operator  == ( const C_OLAPClient_Id& anId )
	{
		if ( m_iId == anId.m_iId )
			return true ; 
		
		return false ; 
	}

	int32 id()
	{
		return m_iId ; 
	}

	operator int() const
	{
		return m_iId ; 
	}

	virtual void Linearize( C_OLAPComm_DataLinearizer& dLin ) ; 
	virtual void DeLinearize( C_OLAPComm_DataDelinearizer& deLin ) ; 

	friend ostream& operator << (ostream& os, 
				const C_OLAPClient_Id& client_id) ; 

protected:

	int32	m_iId ; 
} ;

inline ostream& operator << (ostream& os, const C_OLAPClient_Id& client_id)
{
	os << client_id.m_iId ; return os ;
}
	
#endif 
