/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////
//
// olap_main_thread.h
//
// This file defines the main thread that is started from the main. 
// It initializes the server, starts the backend threads and initializes
// the shore.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_MAIN_THREAD_H)
#define	__OLAP_MAIN_THREAD_H

#include "olap_borg_thread.h"
#include "w_dynarray.h"

class C_OLAPOperator_Thread ; 
class C_OLAPMsg_Service_Thread ;
class C_OLAPClient_Service_Thread ;
class C_OLAPBkend_Thread ; 

class C_OLAPMain_Thread : public C_OLAPBorg_Thread 
{
public:

	C_OLAPMain_Thread() ; 

	~C_OLAPMain_Thread() ;

	virtual void run() ; 

	virtual olap_thread_type GetThreadType()
	{
		return OLAP_MAIN_THREAD ;
	}

	C_OLAPMain_Thread* GetCurrentThread()
	{
		return (C_OLAPMain_Thread *)smthread_t::me() ; 
	}

protected:

	rc_t InitShore( bool format, option_t* device_opt, option_t* max_quota_opt) ;
	rc_t ShutdownShore() ; 

	rc_t WaitForShutdown() ; 

	rc_t ShutdownServer() ; 

	rc_t WaitForRequestDenialShutdown() ; 
	rc_t WaitForClientsShutdown() ; 
	rc_t WaitForMsgClientsShutdown() ; 
	rc_t WaitForOperatorShutdown() ; 
	rc_t WaitForBackendShutdown() ; 
	rc_t WaitForMsgSystemShutdown() ; 

	C_OLAPMsg_Service_Thread*			m_isMsgSvcThread ;
	C_OLAPClient_Service_Thread*			m_isClientSvcThread ;
	dynarray<C_OLAPOperator_Thread*>                m_isOpThreads ;
	dynarray<C_OLAPBkend_Thread*>			m_isBackendThreads ;
	dynarray<sfile_t*>				m_isBackendSocks ;
} ;

#endif
