/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

//////////////////////////////////////////////////////////////////
//
// olap_server_macros.h
//
// This file defines the macros for the printing messages  
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_MACROS_H)
#define	__OLAP_MACROS_H

#include "w_stream.h"
#include "olap_types.h"
#include "olap_msg.h"

#define CALL_SHORE(x)			x
#define CALL_SHORE_NO_RET(x)		x

extern int32 BORG_MSG_LEVEL ; 
extern void VerboseMessage( strstream& strs ) ; 

#define MESSAGE_OUT(X, level)		{ \
	if ( BORG_MSG_LEVEL >= (level) ) \
	{ \
		char		buffer[OLAP_BUFFER_SIZE] ; \
		strstream	str(buffer, OLAP_BUFFER_SIZE) ; \
		str << X << ends ; \
		VerboseMessage( str ) ; \
	} \
}

#define	BORG_MSG_LEVEL_1(X)	MESSAGE_OUT(X,1) 
#define	BORG_MSG_LEVEL_2(X)	MESSAGE_OUT(X,2) 
#define	BORG_MSG_LEVEL_3(X)	MESSAGE_OUT(X,3) 
#define	BORG_MSG_LEVEL_4(X)	MESSAGE_OUT(X,4) 

#endif
