/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

///////////////////////////////////////////////////////////////////
//
// olap_tuple_client_native.h
//
// This file defines the abstract interface for the client stream
// for pipelining the tuples to the client
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_TUPLE_CLIENT_STREAM_H)
#define	__OLAP_TUPLE_CLIENT_STREAM_H

#include "olap_tuple_stream.h"
#include "olap_page.h"

class C_OLAPComm_System ; 

class C_OLAPTuple_ClientStream : public C_OLAPTuple_Stream {
public:

	C_OLAPTuple_ClientStream()
	{
		m_isSystem = NULL ; m_isInputPage = NULL ;  
	}

	virtual ~C_OLAPTuple_ClientStream()
	{
		if ( m_isInputPage ) delete m_isInputPage ; 
	}

protected:

	C_OLAPComm_System*		m_isSystem ; 

	C_OLAP_Page*			m_isInputPage ;
	C_OLAP_Page			m_isOutputPage ;
} ; 

#endif
