/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

///////////////////////////////////////////////////////////////////
//
// olap_tuple_client_shore.h
//
// This file defines the server side of the stream that streams  
// tuples to the client. Uses the nonblocking sockets of shore
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_TUPLE_CLIENT_SHORE_H)
#define	__OLAP_TUPLE_CLIENT_SHORE_H

#include "olap_comm_shore.h"
#include "olap_tuple_client_stream.h"

class C_OLAPTuple_ShoreClientStream : public C_OLAPTuple_ClientStream {
public:

	C_OLAPTuple_ShoreClientStream( sfile_t* sock ) 
	{
		m_isSystem = new C_OLAPComm_System_Shore(sock) ; 
		if ( !m_isSystem ) W_FATAL(BORG_OUTOFMEMORY) ;
	}

	virtual ~C_OLAPTuple_ShoreClientStream()
	{
		if ( m_isSystem ) delete m_isSystem ; 
	}

	virtual w_rc_t  read(C_OLAP_Tuple& aTuple, bool& eos, bool& exception); 
	virtual w_rc_t	SendExceptionDownStream() ; 

        virtual w_rc_t  write( C_OLAP_Tuple& tuple, bool& exception ) ;

	virtual w_rc_t read( C_OLAP_Page*& /*page*/, bool& eos, bool& exception )
        {
                eos = exception = true ;
                return RC(BORG_NOTIMPLEMENTED) ;
        }

        virtual w_rc_t write( C_OLAP_Page* /*page*/, bool& exception )
        {
                exception = true ;
                return RC(BORG_NOTIMPLEMENTED) ;
        }

        virtual w_rc_t  SendEndOfStream() ;
	virtual w_rc_t  SendExceptionUpStream() ;

	virtual void	Reset() ; 

protected:

	w_rc_t  sendAPage( bool& exception ) ;

} ;

#endif 
