/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// borgtypes.h
//
// The BORG type system. Declares the basic BORG types and the class
// OlapType which stores information about a type.
//
// Author: Prasad M. Deshpande
//
/////////////////////////////////////////////////////////////////////



#ifndef _BORGTYPES_H
#define _BORGTYPES_H
#include <olap_types.h>

enum BorgTypes { BORG_UNDEF, BORG_INT, BORG_FLOAT, BORG_STR };

#define VARIABLE_LENGTH 0xffffffff
#define BORGALIGNON 0x8
#define BORGALIGNON1 (BORGALIGNON - 1)
#define borgalign(sz) ((u_int32)((sz + BORGALIGNON1) & ~BORGALIGNON1))

class ostream;

class OlapType
{
public:
    BorgTypes 	m_typeid;
    u_int32 	m_length; // length (= VARIABLE_LENGTH) for var length field
    u_int32	m_alignedlength; // aligned length


    bool VarLength() {
	return m_length == VARIABLE_LENGTH;
    }


    void print(void *buf, u_int32 len, ostream &str);

    static OlapType BasicOlapTypes[]; // defined in "olap_tuple.cpp"
};


#endif
