/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_basics.h
//
// Declares some very basic macros and constants used by BORG.
//
// Author: Prasad M. Deshpande
//
/////////////////////////////////////////////////////////////////////



#ifndef _BASICS_H
#define _BASICS_H
#include <assert.h>
#include <w_dynarray.h>

#define Del(p) if (p) delete p; 
#define DelA(p) if (p) delete [] p;

#ifdef DEBUG
#define OLAP_DBG(x) x;
#else
#define OLAP_DBG(x) ;
#endif

#define borg_assert1(x) assert(x)

#ifdef BORG_DEBUG
#define borg_assert3(x) assert(x)
#else
#define borg_assert3(x) 
#endif

#ifdef _WINDOWS
#define p_err(ERRSTR) { \
	AfxMessageBox(ERRSTR); \
	exit(1); \
	}; 
#else
#define p_err(ERRSTR) { \
    cerr << ERRSTR; \
    exit(1); \
}; 
#endif

#ifdef _WINDOWS
#define ret_err(ERRSTR, ERR) { \
	AfxMessageBox(ERRSTR); \
	return ERR; \
	}; 
#else
#define ret_err(ERRSTR, ERR) { \
    cerr << ERRSTR; \
    return ERR; \
}; 
#endif

#define MAX_NUM_OF_ATTRS 16
/* maximum number of attributes that any relation can have */
#define MAX_NAME_SIZE 512
#define MAX_SQL_SIZE 16384
#define MAX_DESCR_SIZE 100
#define MAX_LEVELS    10    // maximum size of hierarchy
#define MAX_DIMENSIONS 10

enum AggrFunc { Sum = 0, Count, Avg, Max, Min, Id, Computed, M_Invalid};

class C_OLAP_TupleInfo;
typedef dynarray<C_OLAP_TupleInfo*>     TupleTypes;


/* From Metadata common code... */
/* For representation of columns of data ... */

struct DataItem
{
    void* 		Name;
    unsigned int   	Len;
};

bool operator==(struct DataItem I1, struct DataItem I2);
bool operator<(struct DataItem I1, struct DataItem I2);


#endif
