/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_page.cpp
//
// Implementation of the C_OLAP_Page class declared in olap_page.h
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#include "olap_page.h"

C_OLAP_Page::slotid_t C_OLAP_Page::read( C_OLAP_Tuple& aTuple, bool& eop )
{
	if ( next >= nslots )
	{
		eop = true ; return -1; 
	} 

	slotid_t read_slot = next++ ; 
	aTuple.SetTuple( tuple_addr(read_slot), tuple_size(read_slot) ) ; 	
	eop = false ; 

	return read_slot;
}

void C_OLAP_Page::read( C_OLAP_Tuple& aTuple, int slot, bool& eop )
{
	if (slot >= nslots)
        {
                eop = true ; return ;
        }

        slotid_t read_slot = slotid_t(slot);
        aTuple.SetTuple( tuple_addr(read_slot), tuple_size(read_slot) ) ;
        eop = false ;
}


void C_OLAP_Page::write( C_OLAP_Tuple& aTuple, bool& page_full )
{
	if (  free_tuple_space() < aTuple.GetLength() )
	{
		page_full = true ; return ;
	}

	// Write the tuple
	memcpy(&data[free], aTuple.GetTuple(), aTuple.GetLength()) ;  

	// Write the slot information
	slot[-nslots].offset = free ; slot[-nslots].length= aTuple.GetLength() ; 

	nslots++ ; 

	// Update the free offset
	free += aTuple.GetLength() ; page_full = false ; 
}
