/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_utils.h
//
// Has code for some utility functions. Specifically functions used 
// to linearize and delinearize a "dynarray"
//
// Author: Prasad M. Deshpande
//
/////////////////////////////////////////////////////////////////////



#ifndef _OLAP_UTILS_H
#define _OLAP_UTILS_H
#include "w_dynarray.h"
#include "olap_comm_generic.h"

template <class TYPE> void Linearize(dynarray <TYPE>& arr,
                                C_OLAPComm_DataLinearizer  &dLin)
{
    u_int32 i, size = arr.getsize();
    dLin.Pack(int32(size));

    for (i=0; i<size; i++)
        dLin.Pack(arr[i]);
}

template <class TYPE> void DeLinearize(dynarray <TYPE>& arr,
                                C_OLAPComm_DataDelinearizer  &deLin)
{
    u_int32 i, size;
    int32   tmp;
    deLin.Unpack(tmp);
    size = tmp;
    arr.set_size(size);

    for (i=0; i<size; i++)
        deLin.Unpack(arr[i]);
}



#endif
