/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_thread_cond.h
//
// This file contains the interface abstraction for thread condition 
// variable.  
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_THREAD_COND_H)
#define  __OLAP_THREAD_COND_H

#include "olap_thread_mutex.h"

class C_OLAPThread_Condition {

public:

	C_OLAPThread_Condition()
	{
		pthread_cond_init( &m_isCondHandle, NULL ) ; 
		m_bValid = true ;
	}

	~C_OLAPThread_Condition()
	{
		pthread_cond_destroy( &m_isCondHandle ) ; 
		m_bValid = false ;
	}

	int32 Wait( C_OLAPThread_Mutex& mutex )
	{
		if ( !m_bValid ) return -1 ;
		pthread_cond_wait( &m_isCondHandle, &mutex.m_isMutexHandle );
		return 0 ; 
	}

	int32 Signal()
	{
		if ( !m_bValid ) return -1 ; 
		pthread_cond_signal( &m_isCondHandle ) ; 
		return 0 ; 
	}

protected:

	pthread_cond_t		m_isCondHandle ;

	bool			m_bValid ;
} ;


#endif
