/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_thread_mutex.h
//
// This file contains the interface abstraction for thread mutexes 
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_THREAD_MUTEX_H)
#define  __OLAP_THREAD_MUTEX_H

class C_OLAPThread_Mutex {

friend class C_OLAPThread_Condition ; 
public :

	C_OLAPThread_Mutex()
	{
		pthread_mutex_init( &m_isMutexHandle, NULL ) ; 

		m_bValid = true ;
	}

	~C_OLAPThread_Mutex()
	{
		pthread_mutex_destroy( &m_isMutexHandle ) ; 

		m_bValid = false ;
	}

	int32 Lock()
	{
		if ( !m_bValid ) return -1 ;

		int32 iRetVal = pthread_mutex_lock(&m_isMutexHandle) ;

		return iRetVal ; 
	}

	int32 Unlock()
	{
		if ( !m_bValid ) return -1 ; 

		pthread_mutex_unlock(&m_isMutexHandle) ; 
		return 0 ; 
	}

protected :

	pthread_mutex_t		m_isMutexHandle ;
	bool			m_bValid ;

} ;

#endif
