/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_thread_thread.h
//
// This file contains the interface abstraction for various thread 
// operations. To create a new type of thread inherit from this class
// and overload the run method. The thread is started by invoking the
// start method.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_THREAD_THREAD_H)
#define  __OLAP_THREAD_THREAD_H

class C_OLAPThread_Thread {

public:

	C_OLAPThread_Thread()
	{
		memset( &m_isThreadHandle, 0, sizeof(m_isThreadHandle) ) ;
		memset( &m_isThreadAttr, 0, sizeof(m_isThreadAttr) ) ;
		pthread_attr_init( &m_isThreadAttr ) ; 		
	}

	virtual ~C_OLAPThread_Thread()
	{
		pthread_attr_destroy( &m_isThreadAttr ) ; 
	}

	int32 Start() ;

	virtual vo_ptr Run() = 0 ;

	static const u_int32 STACK_SIZE ;
	static vo_ptr StartFunction( vo_ptr arg ) ;

	void Wait() ;

protected:

	int32 End()
	{
		int32		iRetVal ;
		pthread_exit(&iRetVal) ;
		return iRetVal ;
	}

	static int32 Join( C_OLAPThread_Thread& isOlapThread ) ;
	static void Yield() ; 

	vo_ptr					m_isRetVal ; 
	pthread_t				m_isThreadHandle ;
	pthread_attr_t				m_isThreadAttr ;

private:

} ;

extern C_OLAPThread_Thread* OLAPGetCurrentThread() ;


#endif
