/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_thread_print.cpp
//
// This file provides the definition of a C++ style utility to print
// on the screen from multiple threads so that print outs are not garbled.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include "olap_types.h"

#include "olap_thread_mutex.h"

static C_OLAPThread_Mutex      gc_isPrintMutex ;

ostream& lockp(ostream& outs)
{
	gc_isPrintMutex.Lock() ; 

	return outs ; 
}

ostream& unlockp(ostream& outs)
{
	gc_isPrintMutex.Unlock() ; 

	return outs ; 
}
