/*
Copyright (c) 1997-1998
Borg Team
University of Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE BORG TEAM AT THE UNIVERSITY OF WISCONSIN -- MADISON ALLOWS FREE
USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.  WE DISCLAIM ANY
LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
THE USE OF THIS SOFTWARE.

The Borg Team consists of Prasad Deshpande, Karthikeyan Ramasamy,
Amit Shukla and Jeffrey Naughton
*/

////////////////////////////////////////////////////////////////////
//
// olap_thread_thread.h
//
// This file contains the interface abstraction for various thread
// operations. To create a new type of thread inherit from this class
// and overload the run method. The thread is started by invoking the
// start method.
//
// Author: Karthikeyan Ramasamy
//
/////////////////////////////////////////////////////////////////////

#if !defined(__OLAP_THREAD_THREAD_H)
#define  __OLAP_THREAD_THREAD_H

class C_OLAPThread_Thread {

public:

	C_OLAPThread_Thread()
	{
		m_isThreadHandle = NULL ;
	}

	
	virtual ~C_OLAPThread_Thread()
	{
		
	}

	int32 Start() ;


	int32 Suspend() 
	{
		if ( SuspendThread(m_isThreadHandle) == 0xFFFFFFFF )
			return -1 ;

		return 0 ;
	}

	int32 Resume()
	{
		if ( ResumeThread(m_isThreadHandle) == 0xFFFFFFFF )
			return -1 ;

		return 0 ;
	}

	virtual u_int32 Run() = 0 ;

	static const u_int32 STACK_SIZE ;
	static u_int32 _stdcall StartFunction( void* arg ) ;

protected:

	int32 End()
	{
		u_int32		iRetVal ;

		_endthreadex(iRetVal) ;
		return 0 ;
	}

	static int32 Join( C_OLAPThread_Thread& isOlapThread ) ;

	HANDLE				m_isThreadHandle ;

private:

} ;

extern C_OLAPThread_Thread* OLAPGetCurrentThread() ;


#endif
